/**************************************************************************
 *
 * FILE  compat.c
 * Copyright (c) 2019 Daniel Kahlin
 * Written by Daniel Kahlin <daniel@kahlin.net>
 *
 * DESCRIPTION
 *   OS compatibility helpers
 *
 ******/
#include <stdio.h>

#include "compat.h"

/* functions to set binary or text mode on windows */
/* _WIN32 is defined on both 32-bit and 64-bit windows compiles */
#ifdef _WIN32
#include <io.h>
#include <fcntl.h>
void set_binmode(FILE *fp)
{
    setmode(fileno(fp), _O_BINARY);
}
void set_textmode(FILE *fp)
{
    setmode(fileno(fp), _O_TEXT);
}
#else
void set_binmode(FILE *fp) { };
void set_textmode(FILE *fp) { };
#endif

/* eof */
