/**************************************************************************
 *
 * FILE  compat.h
 * Copyright (c) 2019 Daniel Kahlin
 * Written by Daniel Kahlin <daniel@kahlin.net>
 *
 * DESCRIPTION
 *   OS compatibility helpers
 *
 ******/
#ifndef COMPAT_H
#define COMPAT_H

#include <stdio.h>

/* functions to set binary or text mode */
void set_binmode(FILE *fp);
void set_textmode(FILE *fp);


/* hack to fix random for windows compiles */
/* _WIN32 is defined on both 32-bit and 64-bit windows compiles */
#ifdef _WIN32
#define srandom(x) srand(x)
#define random(x) rand(x)
#endif

#endif /* COMPAT_H */
/* eof */
