#ifndef OPCODES_H
#define OPCODES_H

char *tab_mne[] = {
     "brk",  "ora",  "jam",  "slo",  "nop",  "ora",  "asl",  "slo",
     "php",  "ora",  "asl",  "anc",  "nop",  "ora",  "asl",  "slo",
     "bpl",  "ora",  "jam",  "slo",  "nop",  "ora",  "asl",  "slo",
     "clc",  "ora",  "nop",  "slo",  "nop",  "ora",  "asl",  "slo",
     "jsr",  "and",  "jam",  "rla",  "bit",  "and",  "rol",  "rla",
     "plp",  "and",  "rol",  "anc",  "bit",  "and",  "rol",  "rla",
     "bmi",  "and",  "jam",  "rla",  "nop",  "and",  "rol",  "rla",
     "sec",  "and",  "nop",  "rla",  "nop",  "and",  "rol",  "rla",
     "rti",  "eor",  "jam",  "sre",  "nop",  "eor",  "lsr",  "sre",
     "pha",  "eor",  "lsr",  "asr",  "jmp",  "eor",  "lsr",  "sre",
     "bvc",  "eor",  "jam",  "sre",  "nop",  "eor",  "lsr",  "sre",
     "cli",  "eor",  "nop",  "sre",  "nop",  "eor",  "lsr",  "sre",
     "rts",  "adc",  "jam",  "rra",  "nop",  "adc",  "ror",  "rra",
     "pla",  "adc",  "ror",  "arr",  "jmp",  "adc",  "ror",  "rra",
     "bvs",  "adc",  "jam",  "rra",  "nop",  "adc",  "ror",  "rra",
     "sei",  "adc",  "nop",  "rra",  "nop",  "adc",  "ror",  "rra",
     "nop",  "sta",  "nop",  "sax",  "sty",  "sta",  "stx",  "sax",
     "dey",  "nop",  "txa",  "ane",  "sty",  "sta",  "stx",  "sax",
     "bcc",  "sta",  "jam",  "sha",  "sty",  "sta",  "stx",  "sax",
     "tya",  "sta",  "txs",  "tas",  "shy",  "sta",  "shx",  "sha",
     "ldy",  "lda",  "ldx",  "lax",  "ldy",  "lda",  "ldx",  "lax",
     "tay",  "lda",  "tax",  "lax",  "ldy",  "lda",  "ldx",  "lax",
     "bcs",  "lda",  "jam",  "lax",  "ldy",  "lda",  "ldx",  "lax",
     "clv",  "lda",  "tsx",  "las",  "ldy",  "lda",  "ldx",  "lax",
     "cpy",  "cmp",  "nop",  "dcp",  "cpy",  "cmp",  "dec",  "dcp",
     "iny",  "cmp",  "dex",  "sbx",  "cpy",  "cmp",  "dec",  "dcp",
     "bne",  "cmp",  "jam",  "dcp",  "nop",  "cmp",  "dec",  "dcp",
     "cld",  "cmp",  "nop",  "dcp",  "nop",  "cmp",  "dec",  "dcp",
     "cpx",  "sbc",  "nop",  "isc",  "cpx",  "sbc",  "inc",  "isc",
     "inx",  "sbc",  "nop",  "sbc",  "cpx",  "sbc",  "inc",  "isc",
     "beq",  "sbc",  "jam",  "isc",  "nop",  "sbc",  "inc",  "isc",
     "sed",  "sbc",  "nop",  "isc",  "nop",  "sbc",  "inc",  "isc",
};

int tab_size[] = {
         1,      2,      1,      2,      2,      2,      2,      2,
         1,      2,      1,      2,      3,      3,      3,      3,
         2,      2,      1,      2,      2,      2,      2,      2,
         1,      3,      1,      3,      3,      3,      3,      3,
         3,      2,      1,      2,      2,      2,      2,      2,
         1,      2,      1,      2,      3,      3,      3,      3,
         2,      2,      1,      2,      2,      2,      2,      2,
         1,      3,      1,      3,      3,      3,      3,      3,
         1,      2,      1,      2,      2,      2,      2,      2,
         1,      2,      1,      2,      3,      3,      3,      3,
         2,      2,      1,      2,      2,      2,      2,      2,
         1,      3,      1,      3,      3,      3,      3,      3,
         1,      2,      1,      2,      2,      2,      2,      2,
         1,      2,      1,      2,      3,      3,      3,      3,
         2,      2,      1,      2,      2,      2,      2,      2,
         1,      3,      1,      3,      3,      3,      3,      3,
         2,      2,      2,      2,      2,      2,      2,      2,
         1,      2,      1,      2,      3,      3,      3,      3,
         2,      2,      1,      2,      2,      2,      2,      2,
         1,      3,      1,      3,      3,      3,      3,      3,
         2,      2,      2,      2,      2,      2,      2,      2,
         1,      2,      1,      2,      3,      3,      3,      3,
         2,      2,      1,      2,      2,      2,      2,      2,
         1,      3,      1,      3,      3,      3,      3,      3,
         2,      2,      2,      2,      2,      2,      2,      2,
         1,      2,      1,      2,      3,      3,      3,      3,
         2,      2,      1,      2,      2,      2,      2,      2,
         1,      3,      1,      3,      3,      3,      3,      3,
         2,      2,      2,      2,      2,      2,      2,      2,
         1,      2,      1,      2,      3,      3,      3,      3,
         2,      2,      1,      2,      2,      2,      2,      2,
         1,      3,      1,      3,      3,      3,      3,      3,
};

#define OP_IMP (1)
#define OP_IMM (2)
#define OP_ZP  (3)
#define OP_ZPX (4)
#define OP_ZPY (5)
#define OP_ABS (6)
#define OP_ABX (7)
#define OP_ABY (8)
#define OP_IZX (9)
#define OP_IZY (10)
#define OP_REL (11)
#define OP_IND (12)
int tab_amode[] = {
    OP_IMP, OP_IZX, OP_IMP, OP_IZX,  OP_ZP,  OP_ZP,  OP_ZP,  OP_ZP,
    OP_IMP, OP_IMM, OP_IMP, OP_IMM, OP_ABS, OP_ABS, OP_ABS, OP_ABS,
    OP_REL, OP_IZY, OP_IMP, OP_IZY, OP_ZPX, OP_ZPX, OP_ZPX, OP_ZPX,
    OP_IMP, OP_ABY, OP_IMP, OP_ABY, OP_ABX, OP_ABX, OP_ABX, OP_ABX,
    OP_ABS, OP_IZX, OP_IMP, OP_IZX,  OP_ZP,  OP_ZP,  OP_ZP,  OP_ZP,
    OP_IMP, OP_IMM, OP_IMP, OP_IMM, OP_ABS, OP_ABS, OP_ABS, OP_ABS,
    OP_REL, OP_IZY, OP_IMP, OP_IZY, OP_ZPX, OP_ZPX, OP_ZPX, OP_ZPX,
    OP_IMP, OP_ABY, OP_IMP, OP_ABY, OP_ABX, OP_ABX, OP_ABX, OP_ABX,
    OP_IMP, OP_IZX, OP_IMP, OP_IZX,  OP_ZP,  OP_ZP,  OP_ZP,  OP_ZP,
    OP_IMP, OP_IMM, OP_IMP, OP_IMM, OP_ABS, OP_ABS, OP_ABS, OP_ABS,
    OP_REL, OP_IZY, OP_IMP, OP_IZY, OP_ZPX, OP_ZPX, OP_ZPX, OP_ZPX,
    OP_IMP, OP_ABY, OP_IMP, OP_ABY, OP_ABX, OP_ABX, OP_ABX, OP_ABX,
    OP_IMP, OP_IZX, OP_IMP, OP_IZX,  OP_ZP,  OP_ZP,  OP_ZP,  OP_ZP,
    OP_IMP, OP_IMM, OP_IMP, OP_IMM, OP_IND, OP_ABS, OP_ABS, OP_ABS,
    OP_REL, OP_IZY, OP_IMP, OP_IZY, OP_ZPX, OP_ZPX, OP_ZPX, OP_ZPX,
    OP_IMP, OP_ABY, OP_IMP, OP_ABY, OP_ABX, OP_ABX, OP_ABX, OP_ABX,
    OP_IMM, OP_IZX, OP_IMM, OP_IZX,  OP_ZP,  OP_ZP,  OP_ZP,  OP_ZP,
    OP_IMP, OP_IMM, OP_IMP, OP_IMM, OP_ABS, OP_ABS, OP_ABS, OP_ABS,
    OP_REL, OP_IZY, OP_IMP, OP_IZY, OP_ZPX, OP_ZPX, OP_ZPY, OP_ZPY,
    OP_IMP, OP_ABY, OP_IMP, OP_ABY, OP_ABX, OP_ABX, OP_ABY, OP_ABY,
    OP_IMM, OP_IZX, OP_IMM, OP_IZX,  OP_ZP,  OP_ZP,  OP_ZP,  OP_ZP,
    OP_IMP, OP_IMM, OP_IMP, OP_IMM, OP_ABS, OP_ABS, OP_ABS, OP_ABS,
    OP_REL, OP_IZY, OP_IMP, OP_IZY, OP_ZPX, OP_ZPX, OP_ZPY, OP_ZPY,
    OP_IMP, OP_ABY, OP_IMP, OP_ABY, OP_ABX, OP_ABX, OP_ABY, OP_ABY,
    OP_IMM, OP_IZX, OP_IMM, OP_IZX,  OP_ZP,  OP_ZP,  OP_ZP,  OP_ZP,
    OP_IMP, OP_IMM, OP_IMP, OP_IMM, OP_ABS, OP_ABS, OP_ABS, OP_ABS,
    OP_REL, OP_IZY, OP_IMP, OP_IZY, OP_ZPX, OP_ZPX, OP_ZPX, OP_ZPX,
    OP_IMP, OP_ABY, OP_IMP, OP_ABY, OP_ABX, OP_ABX, OP_ABX, OP_ABX,
    OP_IMM, OP_IZX, OP_IMM, OP_IZX,  OP_ZP,  OP_ZP,  OP_ZP,  OP_ZP,
    OP_IMP, OP_IMM, OP_IMP, OP_IMM, OP_ABS, OP_ABS, OP_ABS, OP_ABS,
    OP_REL, OP_IZY, OP_IMP, OP_IZY, OP_ZPX, OP_ZPX, OP_ZPX, OP_ZPX,
    OP_IMP, OP_ABY, OP_IMP, OP_ABY, OP_ABX, OP_ABX, OP_ABX, OP_ABX,
};

#define OP_UND (1)
int tab_umode[] = {
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0,      0, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND,      0,      0,      0, OP_UND,
         0,      0,      0, OP_UND,      0,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0,      0, OP_UND,      0,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0,      0, OP_UND,      0,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
    OP_UND,      0, OP_UND, OP_UND,      0,      0,      0, OP_UND,
         0, OP_UND,      0, OP_UND,      0,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND,      0,      0,      0, OP_UND,
         0,      0,      0, OP_UND, OP_UND,      0, OP_UND, OP_UND,
         0,      0,      0, OP_UND,      0,      0,      0, OP_UND,
         0,      0,      0, OP_UND,      0,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND,      0,      0,      0, OP_UND,
         0,      0,      0, OP_UND,      0,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND,      0,      0,      0, OP_UND,
         0,      0,      0, OP_UND,      0,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND,      0,      0,      0, OP_UND,
         0,      0,      0, OP_UND,      0,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
         0,      0, OP_UND, OP_UND, OP_UND,      0,      0, OP_UND,
};

#endif /* OPCODES_H */
