/**************************************************************************
 *
 * FILE  stream_io.h
 * Copyright (c) 2019 Daniel Kahlin
 * Written by Daniel Kahlin <daniel@kahlin.net>
 *
 * DESCRIPTION
 *   common I/O functions
 *
 ******/
#ifndef STREAM_IO_H
#define STREAM_IO_H

#include <stdio.h>

typedef struct {
    FILE *fp;
    int write_mode;
    int bin_mode;
    const char *print_name;
} Stream;

#if 0
Stream *stream_open(const char *srcname, const char *mode, const char **print_name);
int stream_close(Stream *st);
#endif

Stream *stream_open_warn(const char *srcname, const char *mode, const char **print_name);
int stream_close_warn(Stream *st);
Stream *stream_open_fail(const char *srcname, const char *mode, const char **print_name);
int stream_close_fail(Stream *st);

#endif /* STREAM_IO_H */
/* eof */
